# -*- coding: utf-8 -*-
"""
Created on Sun Nov 10 18:35:24 2019

@author: ANIK SARDAR
"""

'''
                                                 ADDITIONAL FUNCTION
'''                                             

import numpy as np
import os, re, time
#from os import path

#from alarm_trial import *



def last_known_success_process(stored_object,subassembly_instance, gauge_name, machine_status, value):
    '''
    FUNCTION TO DETERMINE THE GAUGE COLOR
    Get the gauge color for last known success instance.
    Stored objects stores data only for last 24 hours.
    last_known_success key will be present for success True cases in last 24 hours
    '''

    # Initializing the list that will contain the last known successt timestamp
    try:
        last_known_success_time_24 = []
        for a, b in stored_object.items():
            for c, d in b.items():
                #print("\n c = {}, d = {} \n".format(c,d))
                if c == subassembly_instance:
                    if gauge_name in d:
                        if 'last_known_success' in d[gauge_name]:
                            #print("\n  a is  {} and  its value is {}\n".format(type(a),a) )
                            last_known_success_time_24 = last_known_success_time_24 + [a]

        if machine_status == 0:
        # Latest success time will be last known success time. Gauge color will be the one that corresponds to the last known success time
        # If no success in last 24 hours then gauge color will be black
            if len(last_known_success_time_24)>0:
                last_known_success_time = max(last_known_success_time_24)
                last_known_success_color = stored_object[last_known_success_time][subassembly_instance][gauge_name]['last_known_success']['color']
                gauge_color         = last_known_success_color
                activate_hour_glass = True
            else:
                last_known_success_color = 'black'
                gauge_color              = last_known_success_color
                activate_hour_glass = True
            value = value
            reason = 'Machine Idle'
        else:
            # When the success is True that is the machine is running then the color will depend on whether it is the first batch or not.
            # Check whether the last batch before this one was a success or not. If not then the current the batch is the first batch and in that case 
            # make the color white, reason: initializing data, success: True, Value 0
            if len(last_known_success_time_24)==1:
                # Since success is true and last known success is has already been updated in the current file, 
                # len of last_known_success_time ==1 would mean this the first batch. And the last batch success is false
                gauge_color = ['white' for x in value]
                value       = [0*x for x in value]
                reason      = 'Initializing Data'
                activate_hour_glass = False
            else:
                # Since this is already in machine_status ==1 loop so there is already one last known success entry for this successful batch.
                # This means the len of last_known_success_time must be at least 2 in this case
                activate_hour_glass = False
                last_known_success_time = max(last_known_success_time_24)
                print('\n last know n success time in machine_status 1 else condition', last_known_success_time)
                last_known_success_color = stored_object[last_known_success_time][subassembly_instance][gauge_name]['last_known_success']['color']
                gauge_color = last_known_success_color
                reason      = ''
                value       = value
          
        return activate_hour_glass, gauge_color, value, reason

    except Exception as e:
        import sys  
        exec_info=sys.exc_info()[2]
        line=exec_info.tb_lineno
        print('\n ##############  ERROR IN last_known_success_process  in  {}  at {} ' .format(str(e),line))              


def calc_indicator(batch, batch_val):
    info = []
    for a, b in enumerate(batch):
        if b == batch_val:
            info = info + [a+1]
            indicator = [batch_val, info]
    return indicator

def event_phases(last_event_phase_no):

    if len(last_event_phase_no) > 1:
        if isinstance(last_event_phase_no[-1],list):
            last_event_phase_no=last_event_phase_no[-1]
    Phases = ''
    i = 0
    while i<len(last_event_phase_no):
        if i!= len(last_event_phase_no)-1:
            Phases = Phases + str(last_event_phase_no[i]) + ','
        else:
            Phases = Phases + str(last_event_phase_no[i])
        i+=1
    
    return Phases

def red_yellow_event_indicator(color, event_indicator_list):
    '''
    put color as 'yellow' or 'red' and event_indicaytor_list as current_deviation or voltage_deviation list
    The function will return yellow_indicator or red_indicator list carrying information about event occurence by 1 or 0 value 
    if 1 present then put phase no value i.e. 1, 2 or 3
    '''
    
    if color in event_indicator_list:
        phase_info  = []
        for phase_no, gauge_color in enumerate(event_indicator_list):
            if gauge_color == color:
#                print(phase_no)
                phase_info = phase_info + [phase_no]
            color_indicator = [1, [x+1 for x in phase_info]]
    else:
        color_indicator = [0]
        
    return color_indicator

def group_phases(value_list, index):
    x_grouped = np.array_split(value_list, 20)
    #    j = 0
    x_1 = []
    x_2 = []
    x_3 = []
    j = 0
    while j<len(x_grouped):
        x_1 = x_1 + [x_grouped[j][:,index[0]]]
        x_2 = x_2 + [x_grouped[j][:,index[1]]]
        x_3 = x_3 + [x_grouped[j][:,index[2]]]
        j+=1
    x_ph1 = list(map(lambda x: np.mean(x), x_1))
    x_ph2 = list(map(lambda x: np.mean(x), x_2))
    x_ph3 = list(map(lambda x: np.mean(x), x_3))

    x_ph= np.array([x_ph1] +[x_ph2] + [x_ph3]).T
    return x_ph

def utilization_machine(value_list):
    index = [1,3,5]
    default_cutoff = 2

    x_ph = group_phases(value_list,index)
    non_idle_partitions = list(map(lambda x: 1 if max(x) > default_cutoff else 0, x_ph))
    return 100*  sum(non_idle_partitions)/ len(non_idle_partitions)

def utilization_load(value_list):
    index = [-3,-2,-1]
    default_cutoff = 0.4
    x_ph = group_phases(value_list,index)
    partition_means = list(map(lambda x: np.mean(x), x_ph))
    non_idle_partitions = list(map(lambda x: 1 if x > default_cutoff else 0, partition_means))
    return 100*  sum(non_idle_partitions)/ len(non_idle_partitions)


def utilization(value_list, gauge_name):
    '''
    To find the partitions of a gauge to be running above cut off
    Applicable to On Time and Load Utilization
    '''
    if gauge_name == "Machine Utilization":
        return utilization_machine(value_list)
    elif gauge_name == "Load Utilization":
        return utilization_load(value_list)

def machine_running_percent(value_list):
    '''
    This is on time / Machine Utilization specific. As it is calculated on current values
    '''
    #x         = np.array_split(u, 20)
    index=[1,3,5]
    x_grouped = np.array_split(value_list, 20)
    j = 0
    i_1 = []
    i_2 = []
    i_3 = []
    while j< len(x_grouped):
        i_1 = i_1 + [x_grouped[j][:,1]]
        i_2 = i_2 + [x_grouped[j][:,3]]
        i_3 = i_3 + [x_grouped[j][:,5]]
        j+=1
    
    i_ph1 = list(map(lambda x: np.mean(x), i_1))
    i_ph2 = list(map(lambda x: np.mean(x), i_2))
    i_ph3 = list(map(lambda x: np.mean(x), i_3))
    
    i_ph= np.array([i_ph1] +[i_ph2] + [i_ph3]).T
   # [1 for max(x)>5 for x in i_ph ]     
    
    non_idle_partitions = list(map(lambda x: 1 if max(x)> 5 else 0, i_ph))
    machine_running_percent = 100*  sum(non_idle_partitions)/ len(non_idle_partitions)

    return machine_running_percent


def AutoDeletion(path_name, argument_list, current_timestamp):  
    '''
    To be Used in INPUT_JSON_PREPROCESSING
    CODE FOR AUTO DELETION
    To delete the write enabled i/p-o/p json files stored in r-pi during testing time
    '''
    current_timestamp = int(current_timestamp)
    for f in os.listdir(path_name):
        if re.search('.json', f):
            if abs(int(f.split('.')[0]) - current_timestamp) > argument_list:
                os.remove(os.path.join(path_name, f))

def AutoDeletion_10(path_name, argument_list, current_timestamp):  
    '''
    To be Used in INPUT_JSON_PREPROCESSING
    CODE FOR AUTO DELETION
    To delete the write enabled i/p-o/p json files stored in r-pi during testing time
    '''
    current_timestamp = int(current_timestamp)
    for f in os.listdir(path_name):
        if re.search('.json', f):
            if abs(int((f.split('.')[0]).split('__')[0]) - current_timestamp) > argument_list:
                os.remove(os.path.join(path_name, f))

def make_list(a, b):
    '''
    Can be utilised in INPUT_PROCESSING
    nlist_1 will store only value as INT
    nlist_2 will store only time
    new_list will merge those two
    '''
    i = 0
    while i<len(a):
        a[i].insert(0, b[i][0])
        i+=1
#        print(i)
#        print(a)
    return a

def phase_wise(raw_data_list):
    '''
    Used in INPUT_PROCESSING 
    This function takes the CSV 10 type data and sort the array rows based on the phase number.    
    '''    
    global df10_ph1, df10_ph2, df10_ph3
    
    phase_1 = list([])
    phase_2 = list([])
    phase_3 = list([])
    for x in raw_data_list:
        if x[0] == 0:
            phase_1 = phase_1 + [x[1:]]
            
        elif x[0] == 1:
            phase_2 = phase_2 + [x[1:]]
            
        else:
            phase_3 = phase_3 + [x[1:]]
            
    df10_ph1 = np.array(phase_1)
    df10_ph2 = np.array(phase_2)
    df10_ph3 = np.array(phase_3)
    
    return df10_ph1, df10_ph2, df10_ph3


def get_threshold(API_list, subassembly_instance, gauge_name, threshold):
    
    for i in API_list:
        #for i in j:
        #print(i)
        if i[0] == subassembly_instance and (i[1] == gauge_name or i[1] == gauge_name.lower()) and threshold in i:
            
            print(i[3])
            return (float(i[3]))

def make_last_event_message(message,total_events):

    if total_events !=0:
        last_event = int(max(message.keys(),key=lambda x:int(x)))
        last_event_time = time.strftime('%Y-%m-%d %H:%M:%S', time.gmtime(last_event) )
        last_event      = str(last_event)
        if 'Yellow' not in message[(last_event)]:
            last_event_color = 'Red'
            last_event_phase_no = message[(str(last_event))]['Red']
            Phases = event_phases(last_event_phase_no)
            last_event_message = 'Total Events (24 hrs): ' + str(total_events) + '; Last Event: ' + last_event_color + '(Phases:'+ Phases+ ')'  +'; Time: ' + str(last_event_time) + ' UTC'

        elif 'Red' not in message[(last_event)]:
            last_event_color = 'Yellow'
            last_event_phase_no = message[(str(last_event))]['Yellow']
            Phases = event_phases(last_event_phase_no)
            last_event_message = 'Total Events (24 hrs): ' + str(total_events) + '; Last Event: ' + last_event_color + '(Phases:'+ Phases+ ')'  +'; Time: ' + str(last_event_time) + ' UTC'
        else:
            Yellow_event = 'Yellow'
            Red_event = 'Red'
            last_event_phase_no_yellow = message[(str(last_event))]['Yellow']
            last_event_phase_no_red = message[(last_event)]['Red']
            Phases_red = event_phases(last_event_phase_no_red)
            Phases_yellow = event_phases(last_event_phase_no_yellow)
            last_event_message = 'Total Events (24 hrs): ' + str(total_events) + '; Last Event: ' + Red_event + '(Phases:'+ Phases_red+ ')'  + ',' + Yellow_event+ '(Phases:' + Phases_yellow + ')' +'; Time: ' + str(last_event_time) + ' UTC'
    else:
        last_event_message = "Total Events (24 hrs): 0 ; Last Event: Not Available"
    return last_event_message


