
from os import path
import simplejson as json

details={}

def get_machine_rules(id):
    global details

    print('id: ',id)
    print(details)
    return details.get(id,{})

def addDetails(gauge_details_json, meta_keys=None):
    global details

    gauge_rule_list = {}
    eventInstances = {}
    metas = {}
                
    #if gauge_details_json!=None:
    for a in gauge_details_json['gaugeUserInputs']:    
        if a['subAssemblyInstance']['name'] not in gauge_rule_list:
            gauge_rule_list[a['subAssemblyInstance']['name']] = {}
        if a['pmFunction']['lowercase_name'] not in gauge_rule_list[a['subAssemblyInstance']['name']]:
            gauge_rule_list[a['subAssemblyInstance']['name']][a['pmFunction']['lowercase_name']] = {}
        gauge_rule_list[a['subAssemblyInstance']['name']][a['pmFunction']['lowercase_name']][a['userRequiredInput']['lowercase_name']] = a['value']
                    
    print("Meta's: ", metas)
    if meta_keys:
        for key,value in meta_keys.items():
            print("Key: ", key)
            metas[key] = gauge_details_json.get(key,value)
    k_factor = int(gauge_details_json['kFactor']) if 'kFactor' in gauge_details_json else 1
    cttype   = int(gauge_details_json['cttype'])  if 'cttype'  in gauge_details_json else 100
    machine_id = gauge_details_json['id']

    print("machine_id: ", machine_id)
    print("Rule list: ", gauge_rule_list)
    details[machine_id] = {
        'gauge_rule_list': gauge_rule_list,
        "eventInstances": eventInstances,
        "metas": metas
    }
    print(details)

def loadGaugeDetails(gauge_details_json_path, metas=None):
    print("Details metas: ", metas)
    if path.exists(gauge_details_json_path):
        print('\n\n if gauge detail json path exists \n\n')
        with open (gauge_details_json_path) as f:                            
            gauge_details_json = json.load(f)                                
    else:                      
        gauge_details_json = None
    addDetails(gauge_details_json,metas)    
    return gauge_details_json            
