from Additional_functions import *
from pynovatec_compute.gauges import GaugeMissingData, GaugeTypeBar, GaugeTypeValue, GaugeBase
from GaugePowerAnalyzerMixin import GaugePowerAnalyzerMixin


class Gauge1MinRaw(GaugePowerAnalyzerMixin,GaugeBase):
    def __init__(self,*args,**kwargs):
        self.gauge_type = 'value'
        super().__init__(*args,**kwargs)
        self.publishing_sensors = 'PF'
        self.trendExistence = True
        self.gauge_color = ['green']
        self.success = True
        self.gauge_style = 'raw'

        self.gauge_output_name = 'RAWTest'
        self.gauge_name = 'RAwTest'
        self.rank = 31
        self.trends = {"trendYMax" : 1000, "trendYMin" : -1}
        self.units = 'volt'



    def get_properties(self):
        p = super().get_properties()
        p['type'] = self.gauge_type
        p['gauge_style'] = self.gauge_style
        p['raw_kpis'] = self.raw_kpis
        return p



    def compute(self):
         self.raw_kpis = {}
         for item in self.csv_32:
             self.raw_kpis[str(item[0])] = {
                 'v1': float(item[1]),
                 'v2': float(item[3]),
                 'v3': float(item[5])
             }

