
from pynovatec_compute.gauges import GaugeMissingData, GaugeTypeValue
from GaugePowerAnalyzerMixin import GaugePowerAnalyzerMixin
from pynovatec_compute.gauges import GaugeMissingData
from Additional_functions import *
import numpy as np

class GaugeMachineUtilization(GaugePowerAnalyzerMixin,GaugeTypeValue):
    def __init__(self,*args,**kwargs):
        kwargs['internal_gauge_name'] = '__test_machine_utilization'
        super().__init__(*args,**kwargs)
        self.gauge_output_name = 'Machine Utilization'
        self.gauge_name = 'Machine Utilization'
        self.pre_yellow_threshold = 80;
        self.publishing_sensors = 'PF'
        self.pre_red_threshold = 95
        self.default_thresholds = {'yellow': 80, 'red': 95}
        self.rank = 1
        self.gaugeLife = 3600
        self.trendExistence = True
        self.userInput = True
        self.trends = {"trendYMax" : 100, "trendYMin" : 0}
        self.units = '%'

    def get_default_stored_object(self):
            return {'historical_ts':{},'last_known_success':{'true':0,'false':0, 'color':['white']}}

    def get_properties(self):
        p = super().get_properties()
        p['type'] = self.gauge_type
        p['unit'] = self.units
        return p


    def compute(self):
        if self.mr_time_percentage is None:
             raise GaugeMissingData("No mr_time_percentage")

        self.mystore()["historical_ts"].update({str(self.current_datetime_stamp): self.mr_time_percentage})
        batches_available =    len(self.mystore()['historical_ts'])
        self.reason = 'data available for: ' + str(int(batches_available/6)) + ' hours only' if batches_available < 24*6 else ''
        machine_running_percent = np.mean(np.array(list(self.mystore()['historical_ts'].values())))
        self.purge_stored_ts_by_time(self.mystore()['historical_ts'],24*60*60)

        if np.isnan(machine_running_percent):
             machine_running_percent = 0

        self.success = True
        self.gauge_color=["green"]
        # self.mart = { 
        #      "10-minute-trend" : self.mr_time_percentage, 
        #      "24-hour-trend" : machine_running_percent, 
        #      "trendYMax" : 100, 
        #      "trendYMin" : 0 
        # }
        self.kpis = { 
             "24-hour-trend" : machine_running_percent,
             "10-minute-trend" : self.mr_time_percentage
        }
        self.values = [machine_running_percent]

class GaugeUsage(GaugeMachineUtilization):
     def __init__(self,*args,**kwargs):
        super().__init__(*args,**kwargs)
        self.gauge_output_name = 'Usage'
        self.gauge_name = 'Usage'
        self.internal_gauge_name = 'usage'
