from pynovatec_compute.gauges import GaugeBase
# from alarm_trial import Alarm
from Additional_functions import *
from arithmetic import mean_time_diff
# from pyanalytics_lib.objectstore.MachineAlarmStore import MachineAlarmStore


# import time

class GaugePowerAnalyzerMixin:
    def __init__(self,*args,**kwargs):
        print("Power Analyzer Mixin init.")
        super().__init__(*args,**kwargs)

    def get_default_stored_object(self):
        so = super().get_default_stored_object()
        so.update({"events": {"yellow":{},"red":{}}})
        return so
        # return {'last_known_success': {'true':0, 'false':0,'color':['white']},"events": {"yellow":{},"red":{}}}

    # Overriding because we need two spaces after ':' instead of one for backward combatability with cloud.
    def get_gauge_full_cluster_name(self):
        return self.subassembly_instance + ':  ' + self.gauge_output_name


    # def update_historical_ts(self):
    #     print("****************** update historical ts ************************")
    #     if self.success:
    #         self.mystore()['last_known_success']['true'] = self.current_datetime_stamp
    #         self.mystore()['last_known_success']['color']=self.gauge_color
    #     else:
    #         self.mystore()['last_known_success']['false'] = self.current_datetime_stamp

    def save_events(self,indicator):
        pass

    def update_indicators(self,indicator,extras=None):
        red_indicator    = red_yellow_event_indicator('red', indicator)
        yellow_indicator = red_yellow_event_indicator('yellow', indicator)
        event_indicator  = min(red_indicator[0] + yellow_indicator[0], 1)
        # try:
        #    self.stored_object.current()[self.subassembly_instance].update({self.gauge_name:{'events':event_indicator, 'y_indicator':yellow_indicator, 'r_indicator':red_indicator }})
        # except:
        #    self.stored_object.current().update({self.subassembly_instance:{self.gauge_name:{'events':event_indicator, 'y_indicator':yellow_indicator, 'r_indicator':red_indicator }}})
        # if extras:
        #     print(self.stored_object.current()[self.subassembly_instance][self.gauge_name])
        #     self.stored_object.current()[self.subassembly_instance][self.gauge_name].update(extras)

        addExtras = False
        if yellow_indicator[0] > 0:
            self.mystore()['events']["yellow"].update({str(self.current_datetime_stamp): yellow_indicator})
            addExtras = True
        if red_indicator[0] > 0:
            self.mystore()['events']["red"].update({str(self.current_datetime_stamp): red_indicator})
            addExtras = True
        self.purge_stored_ts_by_time(self.mystore()['events']["yellow"],24*60*60)
        self.purge_stored_ts_by_time(self.mystore()['events']["red"],24*60*60)
        if addExtras and extras is not None:
            for key,value in extras.items():
                print("key is: ",key)
                self.mystore()[key].update({str(self.current_datetime_stamp): value})
                self.purge_stored_ts_by_time(self.mystore()[key],24*60*60)

    def get_event_indicator_message(self):
        data = self.mystore()['events']
        message = {}
        for ts,item in data['red'].items():
            if ts not in message:
                message[ts] = {}
            message[ts].update({"Red": item})
        for ts,item in data['yellow'].items():
            if ts not in message:
                message[ts] = {}
            message[ts].update({"Yellow": item[1]})
        return message
    
    def get_text_under_gauge(self):
        message = self.get_event_indicator_message()
        print("TEXT new message: ",message)
        total_events = len(message)

        new_text = make_last_event_message(message,total_events)
        print("TEXT new text: ",new_text)
        return new_text

    def get_text_under_gauge_old(self,gname):
        text = self.stored_object.get_text_under_gauge(gname, self.subassembly_instance)
        print("TEXT: ",text)
        self.get_new_text_under_gauge()
        return text
    
    def get_worst_event_data_max(self):
        batch_events = self.mystore()['batch_v_min']
        print("WORST BATCH: Batch Events: ",batch_events)
        if not batch_events:
            return {}
        ts_values=[]
        batch_ts = res = next(iter(batch_events))
        max_val = batch_events[batch_ts][0]
        for ts,event in batch_events.items():
            if event[0] >= max_val:
                max_val = event[0]
                batch_ts = ts
            ts_values.append(int(ts))
        mtd = mean_time_diff(ts_values)
        worst_event_info = {
            'ts': batch_ts,
            # 'last': max(ts_values),
            'event': batch_events[batch_ts]
        }
        return worst_event_info
    
    def calc_mtd(self):
        ts_values=[int(x) for x in self.mystore()['batch_v_min'].keys()]
        mtd = mean_time_diff(ts_values)
        return mtd
    
    def get_worst_event_data_min(self):
        batch_events = self.mystore()['batch_v_min']
        if not batch_events:
            return {}
        ts_values=[]
        batch_ts = res = next(iter(batch_events))
        min_val = batch_events[batch_ts][0]
        for ts,event in batch_events.items():
            if event[0] <= min_val:
                min_val = event[0]
                batch_ts = ts
            ts_values.append(int(ts))
        worst_event_info = {
            'ts': batch_ts,
            # 'last': max(ts_values),
            'event': batch_events[batch_ts]
        }
        return worst_event_info
    

    def get_worst_event_info(self):
        if self.gauge_name == 'Under Voltage' or self.gauge_name == 'Sag':
            worst_event_info = self.get_worst_event_data_min()
        else:
            worst_event_info = self.get_worst_event_data_max()
        return worst_event_info

    def get_worst_event_message(self):
        return ""
    
    def get_worst_event_text(self):
        total_events = len(self.mystore()['batch_v_min'])
        last_event_message = self.get_text_under_gauge()
        if total_events == 0:
            return last_event_message

        worst_event_message = self.get_worst_event_message()
        mtd = self.calc_mtd()
        mtd = str(round(mtd,3)) + ' seconds' if mtd else 'Not Available'
        interarrival_time_message = ';  Inter Arrival Time (24 Hrs): Average duration between undervoltage events ' + str(mtd)
        text_under_gauge = last_event_message  + worst_event_message + interarrival_time_message
        return text_under_gauge

    def get_worst_event_text_old(self):
        text = self.stored_object.worst_event_text(self.gauge_name, self.subassembly_instance)
        text_new = self.get_worst_event_text_new()
        print("XXWORST TEXT    : ", text)
        print("XXWORST NEW TEXT: ",text_new)
        return text