import sys

sys.path.insert(0,"../src")
print("testenv..")

import os
import glob
import simplejson as json
import min_10_gauges
import min_1_gauges
from pynovatec_compute.gauges import GaugeBase
from pynovatec.helpers import read_json_from_file,write_json_to_file


machine_details_file="../test_data/json_data/machine_details_0.json"
#rules:  {'motorSense1': {'display_name': 'Electrical Panel1', '__test_current_imbalance': {'pm_function_name': 'Current Imbalance', 'rules': [{'name': 'yellow_threshold', 'type': 'float'}, {'name': 'red_threshold', 'type': 'float'}]}, '__test_current_thd': {'pm_function_name': 'Current Harmonic Distortion', 'rules': [{'name': 'yellow_threshold', 'type': 'float'}, {'name': 'red_threshold', 'type': 'float'}]}}}

def make_gauge_rule(c):
    print("Add Gauge Rules..")
    if not c:
        return {}
    if not hasattr(c,"__pm_function_name__"):
        return {}
    if not hasattr(c,'__rules__'):
        return
    pm_function = c.__pm_function_name__
    rule = c.__rules__
    if hasattr(c,'__internal_gauge_name__'):
        gn=c.__internal_gauge_name__
    else:
        gn=c.__name__.lower()
    
    x={}
    x[gn]={
        'display_name': pm_function,
        'rules': rule
    }
    print("X is: ",x)
    return x 

def show_gauges(c,rules):
    if not c:
        return rules
    print(c.__name__)
    x=make_gauge_rule(c)
    if x:
        rules.update(x)
    subs=c.__subclasses__()
    print(subs)
    for sub in subs:
        rules=show_gauges(sub,rules)
        print(rules)
    return rules

def make_machine_gauge_rules(machine_details):
    print("machine_details_file: ", json.dumps(machine_details,indent=3))
    rules={}
    for sa in machine_details['sensorAssignments']:
        subassembly_instance_name=sa['subAssemblyInstance']['name']
        subassembly_instance_display_name=sa['subAssemblyInstance']['display_name']

        print("Name: ",subassembly_instance_name)
        rule={}
        rule=show_gauges(GaugeBase,rule)
        rule['display_name'] = subassembly_instance_display_name
        rules.update({
            subassembly_instance_name: rule

        })
    return rules


def gen_gauge_rules(machine_file,dest_dir="/tmp"):
    try:
        machine_details = read_json_from_file(machine_file)
        machine_id=machine_details['id']
        rules = make_machine_gauge_rules(machine_details)
    except:
        return {}
    machine_rules={machine_id:rules}
    if dest_dir:
        outfile=os.path.join(dest_dir, f"rules_{machine_id}.json")
        write_json_to_file(outfile,rules)

    return machine_rules

def gen_all_gauge_rules(details_dir,dest_dir="/tmp",dest_file="machine_rules.json"):
    print("details_dir: ",details_dir)
    files=glob.glob(f"{details_dir}/machine*")
    print("files: ", files)
    rule_list={}
    for f in files:
        r=gen_gauge_rules(f,dest_dir=dest_dir)
        rule_list.update(r)
    machine_rules_file=os.path.join(dest_dir,dest_file)
    print("Generating file: ",machine_rules_file)
    write_json_to_file(machine_rules_file,rule_list)
    return rule_list
