# -*- coding: utf-8 -*-
"""
Created on Sun Nov 10 18:35:24 2019

@author: ANIK SARDAR
"""

'''                                                  ____________
                                                     1 MIN GAUGES
                                                     
                                        v_rms | i_rms | power_factor | active_power            
                                       ____________________________________________
'''

import traceback
from Gauge1MinGauges import GaugeVRMS,GaugeIRMS, GaugeActivePower, GaugePowerFactor, GaugeActiveEnergyTotal
from pynovatec_compute.gauges import GenGauges

gauge_dict_1min = {

}

def get_default_1min_gauge_list(subassembly):
    gauge_list = [
        GaugeVRMS,
        GaugeIRMS,
        GaugeActivePower,
        GaugePowerFactor,
        GaugeActiveEnergyTotal
    ]
    return gauge_list

def get_1min_gauge_list(subassembly):
    low_sub= subassembly.lower()
    if low_sub in gauge_dict_1min:
        return gauge_dict_1min[low_sub]
    return get_default_1min_gauge_list(subassembly)


from Gauge1MinRaw import Gauge1MinRaw

def min_1_raw_gauges(json_data,subassembly_instance, subassembly, output_format=1 ):
        print("--------------------- RAW GAUGE ---------------------------")
        # gauge_kwargs = min_1_dict.copy()
        # csv_32 = json_data["subassemblies"][subassembly_instance]["CSV_32"][0]
        gauge_kwargs = {}
        print("json_data: ",json_data)
        csv_32 = json_data["subassemblies"][subassembly_instance]["collectors"]["pf1"]["CSV_32"][0]
        print("CSV_32: ",csv_32)
        gauge_kwargs.update({
            'subassembly_instance': subassembly_instance,
            'subassembly': subassembly,
            'output_format': output_format,
            'create': True,
            'csv_32': csv_32
        })
        gauge_list = [Gauge1MinRaw]
        return GenGauges(gauge_list,**gauge_kwargs)

def min_1_gauges(min_1_dict,subassembly_instance, subassembly, output_format=1 ):
    
    try:
        gauge_kwargs = min_1_dict.copy()
        gauge_kwargs.update({
            'subassembly_instance': subassembly_instance,
            'subassembly': subassembly,
            'output_format': output_format
        })
        gauge_list = get_1min_gauge_list(subassembly)
        return GenGauges(gauge_list,**gauge_kwargs)
    except Exception as e:
        import sys
        exec_info=sys.exc_info()[2]
        line=exec_info.tb_lineno
        print('\n ##############  ERROR IN MIN 1 GAUGES  in  {}  at {} ' .format(str(e),line))
        print(traceback.format_exc())

