# from poweranalyzer_compute import main_output
import json
import simplejson as json
from pynovatec import helpers
import sys
import appconfig
#from pyanalytics_lib.objectstore import ObjectStore
from pynovatec_compute.objectstore import ObjectStore
import getopt
from simplenumpyencoder import NumpyEncoder
from pyanalytics_lib.loggers import  LoggerInit,log_purge,log_save
from pynovatec_compute.gauges import loadGaugeDetails
import os
from poweranalyzer_compute import PowerAnalyzerOneMinBatchProcessor, PowerAnalyzerTenMinBatchProcessor

file="1672309667__machine-59a23930-85b2-11ed-880b-9f470c0f505d.json"
#file="0010.json"
#file="1657670426-pa.json"
config_file=None
batch_duration='10'

default_config = {
    'json_details_path':"../json_data",
    'stored_objects_directory':"/tmp/novatec/stored_objects",
    'log_file': '/tmp/reason.log',
    'output_format': 1,
    'include_vmart': True
}

try:
    opts, args = getopt.getopt(sys.argv[1:],"c:b:")
except getopt.GetoptError:
    print("Error: Error Loading Configuration Details: ")
for opt,arg in opts:
    #print("opt is: ",opt)
    if opt == "-c":
       config_file = arg
    if opt == "-b":
       batch_duration= arg

pfile = args[0]


if (config_file):
    appconfig.loadf(config_file,default_config)
else:
    appconfig.set("json_details_path","../json_data")
    appconfig.stored_objects_directory = "/tmp/novatec/stored_objects"

#print("App config: ",appconfig.dump())

gauge_details_json_path = os.path.join(appconfig.json_details_path,'gauge_details_0.json')
print("gauge_details_json: ", gauge_details_json_path)
loadGaugeDetails(gauge_details_json_path,metas={'kFactor': 1, 'cttype':100})


#print(pfile)
file=pfile
ObjectStore(appconfig.stored_objects_directory)
LoggerInit(appconfig.log_file)

OneMinInputStreamers = []
OneMinOutputStreamers = []
OneMinBatchProcess = PowerAnalyzerOneMinBatchProcessor(OneMinInputStreamers, OneMinOutputStreamers)

TenMinInputStreamers = []
TenMinOutputStreamers = []
TenMinBatchProcess = PowerAnalyzerTenMinBatchProcessor(TenMinInputStreamers, TenMinOutputStreamers)



input_json = helpers.read_json_from_file(file)
print("batch duration: ", batch_duration)
if batch_duration == '10':
    output = TenMinBatchProcess.processBatch(input_json,output_format=appconfig.output_format, include_vmart=appconfig.include_vmart)
else:
    output = OneMinBatchProcess.processBatch(input_json,output_format=appconfig.output_format, include_vmart=appconfig.include_vmart)
# output = main_output(batch_duration,input_json,output_format=appconfig.output_format, include_vmart=appconfig.include_vmart)
log_purge()
log_save()
print("Output generated...")

#print(json.dumps(output,indent=4))
print(json.dumps(output,cls=NumpyEncoder,ignore_nan=True))
#print(json.dumps(output,indent=4))

with open("output.json", 'w') as f:
	json.dump(output, f)
