#!/bin/bash


LOGINNAME="analytics"
PASSWORD="welcome1"

: ${LOGINNAME:=''}
: ${PASSWORD:=''}
: ${DATE:='2022-07-13'}
: ${COMPANY:="NolatoContour"}
: ${DEVICE:="CDA09_pf_cdah1-20-000198"}
: ${DATA_DIR:='input_data'}

echo "USERNAME= $LOGINNAME"

CURL_CMD="curl -s -u ${LOGINNAME}:${PASSWORD}"
#BASE_URL="https://routput.machinesense.com:3043"
BASE_URL="https://routput-new.machinesense.com/input"

CURL_BASE="${CURL_CMD} ${BASE_URL}"


mkdir -p $DATA_DIR
#curl -s -u analytics:look3 https://routput.machinesense.com:3043/2020-07-03/HellermannTyton/MAC7/ | awk '{print $2}' | awk -F '>' '{print $1}' | awk -F '=' '{print $2}' | tr -d '"' | grep output

REMOTE_DIR="${DATE}/${COMPANY}/${DEVICE}"

echo ${CURL_BASE}/${REMOTE_DIR}

files=$(${CURL_BASE}/${REMOTE_DIR}/ \
	| awk '{print $2}' \
	| awk -F '>' '{print $1}' \
	| awk -F '=' '{print $2}' \
	| tr -d '"' \
	)

echo "Files: ",$files
dest_dir=${DATA_DIR}/${COMPANY}/${DEVICE}/${DATE}
mkdir -p $dest_dir
for file in $files
do
	echo $file
	if [ ! -f ${dest_dir}/$file ] ; then
		$CURL_CMD -o ${dest_dir}/$file \
			$BASE_URL/$REMOTE_DIR/$file
	fi
	
done
